
import bpy
import sys
import os

argv = sys.argv
argv = argv[argv.index("--") + 1:] 
FILEPATH= argv[0]
TYPES=argv[1].split(":--separator--:")
NAMES=argv[2].split(":--separator--:")
#bpy.ops.wm.open_mainfile(filepath=FILEPATH,load_ui =False)
context = bpy.context
scene = context.scene
def is_image_loaded(image):
    if image:
        return True if image.size[0] else False
    return False
def get_all_nodes_from_material(node_tree):
    groups=[]
    groups.extend(node_tree.nodes[:])
    for node in node_tree.nodes:
        if node.type=='GROUP':
            groups.extend(get_all_nodes_from_material(node.node_tree))
    return groups
def get_images_from_material(mat):
    images=[]
    if mat.use_nodes:
        for i in get_all_nodes_from_material(mat.node_tree):
            if i.type=='TEX_IMAGE' or i.type=='TEX_ENVIRONMENT':
                if i.image:
                    images.append(i.image)
    return images
for i,a in enumerate(TYPES):
    if a=='MATERIAL':
        for mat in bpy.data.materials:
            if mat.name==NAMES[i]:
                if not all([is_image_loaded(a) for a in get_images_from_material(mat)]):
                    print("Removing:",mat.name)
                    bpy.data.materials.remove(mat)
                    
bpy.ops.wm.save_mainfile()
bk = FILEPATH + "1"
if os.path.exists(bk):
    os.remove(bk)
#bpy.ops.wm.quit_blender()
