import os
import sys
import time
import subprocess
import multiprocessing.managers
import random
import traceback

print(sys.argv)
# filepath=sys.argv[1]
# print(sys.argv)
# time.sleep(5)

blender_executable=r'c:\Program Files\Blender Foundation\Blender 3.3\blender.exe'
files_list=[]
arglist = []
def add_to_list(filepath):
    # print("[>] Selected:", filepath)
    arglist.append(filepath)
def create_fbx_assets_from_path(path):
    cmd = [blender_executable]
    #cmd.append("--background")
    #cmd.append(path)
    # cmd.append("--factory-startup")
    cmd.append("--addons")
    cmd.append("True-Assets")
    
    cmd.append("--python")

    cmd.append(os.path.join(os.path.dirname(
        os.path.abspath(__file__)), "mark_fbx_assets.py"))
    cmd.append('--')
    cmd.append(":-path-:".join(path))
    #t1=threading.Thread(target=functools.partial(run,cmd))
    #t1.start()
    subprocess.run(cmd)
def action(filepaths):
    filepath=filepaths[0]
    # print("[>] Selected:", filepath)
    filetype=os.path.splitext(filepath)[1].replace(".","").lower()
    cmd = [ blender_executable ]
    #cmd.append("--background")
    #cmd.append(path[0])
    if f"import{filetype}.py" in os.listdir(os.path.dirname(__file__)):
        cmd.append("--python")
        cmd.append(os.path.join(os.path.dirname(
            os.path.abspath(__file__)), f"import{filetype}.py"))
        cmd.append('--')
        cmd.extend(filepaths)
        subprocess.run(cmd)
    else:
        print("File Type Not Supported!")
        exit=input("Press any key to Exit!")

class DataManager(multiprocessing.managers.SyncManager):
    pass

global_filelist = []
def get_filelist():
    return global_filelist

if __name__ == "__main__":
    DataManager.register("filelist")
    manager = DataManager(
        ("127.0.0.1", 42068),
        authkey="noice".encode('utf-8')
    )
    try:
        # time.sleep(rand_time)
        # Attempt connecting to an existing process.
        while True:
            try:
                f = os.open(os.path.join(os.getcwd(),'lockfile.lock'),os.O_RDWR | os.O_CREAT | os.O_EXCL)
                os.close(f)
                break
            except Exception as e:
                continue
        manager.connect()
        os.remove(os.path.join(os.getcwd(),'lockfile.lock'))
            # OSLockedAction(target=manager.connect,DEBUG=True)

        # print("Client Ready!")
        filelist = manager.filelist()
        #print(dir(filelist))
        filelist.append(sys.argv[1])
        #print(filelist)
        # time.sleep(10)
    except Exception as e:
        
        # print(e)
        # Start server when unable to connect as a client.
        DataManager.register(
            "filelist", get_filelist
        )
        # print("Starting server ... ")
        manager.start()
        os.remove(os.path.join(os.getcwd(),'lockfile.lock'))
        filelist = manager.filelist()
        filelist.append(sys.argv[1])
        while True:
            try:
                filepath = filelist.pop()
                # print("Received: ", filepath)
                add_to_list(filepath)
            
            except IndexError:
                # Sleep for some time to give time to launch other processes
                # print("Waiting for more files ... ")
                time.sleep(1)
                # print(filelist)
                # If no new data, terminate
                try:
                    item = filelist.pop()
                    filelist.append(item)
                except Exception: break
        manager.shutdown()
        print(len(arglist),"Files Selected")
        create_fbx_assets_from_path(arglist)
            # m=input("a")
        # i=input("Server Exit!")