import os
import sys
import time
import subprocess
import multiprocessing.managers
script_name=sys.argv[1]
blender_executable=r'd:\Program Files\Blender\blender-4.2.0-test2\blender.exe'
files_list=[]
arglist = []
def add_to_list(filepath):
    arglist.append(filepath)
direct_scripts=['movetoassetlibrary',]
def call_script_directly(path):
    cmd=[sys.executable,]
    cmd.append(os.path.join(os.path.dirname(
        os.path.abspath(__file__)), f"{script_name}.py"))
    cmd.append('--')
    cmd.append(":-path-:".join(path))
    subprocess.run(cmd)
def call_script(path):
    if script_name in direct_scripts:
        call_script_directly(path)
    else:
        cmd = [blender_executable]
        #cmd.append("--background")
        #cmd.append(path)
        cmd.append("--factory-startup")
        # cmd.append("--addons")
        # cmd.append("True-Assets")
        
        cmd.append("--python")

        cmd.append(os.path.join(os.path.dirname(
            os.path.abspath(__file__)), f"{script_name}.py"))
        cmd.append('--')
        cmd.append(":-path-:".join(path))
        subprocess.run(cmd)
class DataManager(multiprocessing.managers.SyncManager):
    pass

global_filelist = []
def get_filelist():
    return global_filelist

if __name__ == "__main__":
    
    DataManager.register("filelist")
    manager = DataManager(
        ("127.0.0.1", 42068),
        authkey="noice".encode('utf-8')
    )
    try:
        while True:
            try:
                f = os.open(os.path.join(os.getcwd(),'lockfile.lock'),os.O_RDWR | os.O_CREAT | os.O_EXCL)
                os.close(f)
                break
            except Exception as e:
                continue
        manager.connect()
        os.remove(os.path.join(os.getcwd(),'lockfile.lock'))
        filelist = manager.filelist()
        filelist.append(sys.argv[2])
    except Exception as e:
        DataManager.register(
            "filelist", get_filelist
        )
        manager.start()
        os.remove(os.path.join(os.getcwd(),'lockfile.lock'))
        filelist = manager.filelist()
        filelist.append(sys.argv[2])
        while True:
            try:
                filepath = filelist.pop()
                add_to_list(filepath)
            
            except IndexError:
                time.sleep(1)
                try:
                    item = filelist.pop()
                    filelist.append(item)
                except Exception: break
        manager.shutdown()
        print(len(arglist),"Files Selected")
        call_script(arglist)