
import bpy
import sys
import os

argv = sys.argv
argv = argv[argv.index("--") + 1:] 
FILEPATH= argv[0]
TYPES=argv[1].split(":--separator--:")
NAMES=argv[2].split(":--separator--:")
CHANGE_DISPLACEMENT_TYPE=eval(argv[3])
REMOVE_SUBDIV=eval(argv[4])
#bpy.ops.wm.open_mainfile(filepath=FILEPATH,load_ui =False)
context = bpy.context
scene = context.scene
for i,a in enumerate(TYPES):
    if a=='COLLECTION':
        if bpy.data.collections.get(NAMES[i]):
            for obj in bpy.data.collections.get(NAMES[i]).all_objects:
                if obj.name==NAMES[i]:
                    if CHANGE_DISPLACEMENT_TYPE and hasattr(obj.data,'materials'):
                        for m in obj.data.materials:
                            m.cycles.displacement_method='BUMP'
                    if REMOVE_SUBDIV:
                        for m in obj.modifiers:
                            if m.type=='SUBSURF':
                                try:
                                    obj.modifiers.remove(m)
                                except Exception as e:
                                    print("Could not remove Subdiv modifier!",e)
    elif a=='OBJECT':
        
        for obj in bpy.data.objects:
            if obj.name==NAMES[i]:
                if CHANGE_DISPLACEMENT_TYPE and hasattr(obj.data,'materials'):
                    for m in obj.data.materials:
                        m.cycles.displacement_method='BUMP'
                if REMOVE_SUBDIV:
                    for m in obj.modifiers:
                        if m.type=='SUBSURF':
                            try:
                                obj.modifiers.remove(m)
                            except Exception as e:
                                print("Could not remove Subdiv modifier!",e)
    elif a=='MATERIAL':
        for mat in bpy.data.materials:
            if mat.name==NAMES[i]:
                mat.cycles.displacement_method='BUMP'
bpy.ops.wm.save_mainfile()
bk = FILEPATH + "1"
if os.path.exists(bk):
    os.remove(bk)
#bpy.ops.wm.quit_blender()
