import bpy
import sys
import os
import time
import functools
import mathutils
import random
import uuid
import addon_utils
import re
import json

argv = sys.argv
argv = argv[argv.index("--") + 1:] 

def preferences():
    return bpy.context.preferences.addons[__package__].preferences
true_assets_location=os.path.dirname(__file__)
FILEPATHS= argv[0].split(":-path-:")
for filepath in FILEPATHS:
    bpy.ops.wm.read_homefile(app_template="")
    for obj in bpy.data.objects:
        # if obj.type not in {'LIGHT','CAMERA'}:
            bpy.data.objects.remove(obj)
    arguments={}
    directory=os.path.dirname(__file__)
    try:
        if os.path.isfile(os.path.join(directory,"fbx_settings.txt")):
            with open(os.path.join(directory,"fbx_settings.txt"),mode="r") as f:
                arguments=json.load(f)
                print(arguments)
    except Exception as e:
        print("Error while reading parameters!")
        print("Error Message: ",e)
    bpy.ops.import_scene.fbx(filepath=filepath, ui_tab='MAIN',**arguments)   
    bpy.ops.wm.save_mainfile('EXEC_DEFAULT',filepath=os.path.join(os.path.dirname(filepath),os.path.splitext(os.path.basename(filepath))[0]+".blend"))
    # 
    # bpy.ops.wm.console_toggle()
bpy.ops.wm.quit_blender()