
import bpy
import sys
argv = sys.argv
argv = argv[argv.index("--") + 1:] 
FILEPATH= argv[0]
TYPES=argv[1].split(":--separator--:")
NAMES=argv[2].split(":--separator--:")
WORKSPACE=argv[3]
context = bpy.context
scene = context.scene
try:
    bpy.context.window.workspace=bpy.data.workspaces.get(WORKSPACE) if bpy.data.workspaces.get(WORKSPACE) else bpy.context.window.workspace
    for screen in bpy.data.screens:
        for area in screen.areas:
            if area.spaces.active.type=='VIEW_3D':
                area.spaces.active.shading.use_scene_world=False
                area.spaces.active.shading.use_scene_world_render=False
except Exception as e:
    print(e)
try:
    for i,a in enumerate(TYPES):
        if a=='OBJECT':
            obj=bpy.data.objects.get(NAMES[i])
            if obj and obj not in scene.collection.objects[:]:
                scene.collection.objects.link(obj)
        elif a=='COLLECTION':
            col=bpy.data.collections.get(NAMES[i])
            if col and col not in scene.collection.children[:]:
                scene.collection.children.link(col)
except Exception as e:
    print(e,"An Error Occured!")
