
import bpy
import sys
import os

argv = sys.argv
argv = argv[argv.index("--") + 1:] 
FILEPATH= argv[0]
TYPES=argv[1].split(":--separator--:")
NAMES=argv[2].split(":--separator--:")
TAGS=argv[3]
AUTHOR=argv[4]
DESCRIPTION=argv[5]
REPLACE=True if argv[6]=='Replace' else False
if len(argv)>7:
    REPLACEMENT_TAGS_OLD=argv[7].split(":--separator--:")
    REPLACEMENT_TAGS_NEW=argv[8].split(":--separator--:")
#bpy.ops.wm.open_mainfile(filepath=FILEPATH,load_ui =False)
context = bpy.context
scene = context.scene
if TAGS:
    try:
        for i,a in enumerate(TYPES):
            if a=='COLLECTION':
                if REPLACE:
                    for tag in bpy.data.collections.get(NAMES[i]).asset_data.tags:
                        bpy.data.collections.get(NAMES[i]).asset_data.tags.remove(tag)
                for tag in TAGS.split(","):
                    bpy.data.collections.get(NAMES[i]).asset_data.tags.new(tag)
                
            elif a=='OBJECT':
                if REPLACE:
                    for tag in bpy.data.objects.get(NAMES[i]).asset_data.tags:
                        bpy.data.objects.get(NAMES[i]).asset_data.tags.remove(tag)
                for tag in TAGS.split(","):
                    bpy.data.objects.get(NAMES[i]).asset_data.tags.new(tag)
            elif a=='MATERIAL':
                if REPLACE:
                    for tag in bpy.data.materials.get(NAMES[i]).asset_data.tags:
                        bpy.data.materials.get(NAMES[i]).asset_data.tags.remove(tag)
                for tag in TAGS.split(","):
                    if tag not in [a.name for a in bpy.data.materials.get(NAMES[i]).asset_data.tags]:
                        bpy.data.materials.get(NAMES[i]).asset_data.tags.new(tag)
                for tag in bpy.data.materials.get(NAMES[i]).asset_data.tags:
                    if tag.name in REPLACEMENT_TAGS_OLD:
                        tag_name=tag.name
                        bpy.data.materials.get(NAMES[i]).asset_data.tags.remove(tag)
                        bpy.data.materials.get(NAMES[i]).asset_data.tags.new(REPLACEMENT_TAGS_NEW[REPLACEMENT_TAGS_OLD.index(tag_name)])
            elif a=='WORLD':
                if REPLACE:
                    for tag in bpy.data.worlds.get(NAMES[i]).asset_data.tags:
                        bpy.data.worlds.get(NAMES[i]).asset_data.tags.remove(tag)
                for tag in TAGS.split(","):
                    bpy.data.worlds.get(NAMES[i]).asset_data.tags.new(tag)
            elif a=='NODETREE':
                if REPLACE:
                    for tag in bpy.data.node_groups.get(NAMES[i]).asset_data.tags:
                        bpy.data.node_groups.get(NAMES[i]).asset_data.tags.remove(tag)
                for tag in TAGS.split(","):
                    bpy.data.node_groups.get(NAMES[i]).asset_data.tags.new(tag)
    except Exception as e:
        print("An Error Occured while updating tags",e)
if AUTHOR:
    try:
        for i,a in enumerate(TYPES):
            if a=='COLLECTION':
                bpy.data.collections.get(NAMES[i]).asset_data.author=AUTHOR 
                
            elif a=='OBJECT':
                bpy.data.objects.get(NAMES[i]).asset_data.author=AUTHOR
            elif a=='MATERIAL':
                bpy.data.materials.get(NAMES[i]).asset_data.author=AUTHOR 
            elif a=='WORLD':
                bpy.data.worlds.get(NAMES[i]).asset_data.author=AUTHOR
            elif a=='NODETREE':
                bpy.data.node_groups.get(NAMES[i]).asset_data.author=AUTHOR 
    except:
        print("An Error Occured while updating author")
if DESCRIPTION:
    try:
        for i,a in enumerate(TYPES):
            if a=='COLLECTION':
                bpy.data.collections.get(NAMES[i]).asset_data.description=DESCRIPTION 
                
            elif a=='OBJECT':
                bpy.data.objects.get(NAMES[i]).asset_data.description=DESCRIPTION
            elif a=='MATERIAL':
                bpy.data.materials.get(NAMES[i]).asset_data.description=DESCRIPTION 
            elif a=='WORLD':
                bpy.data.worlds.get(NAMES[i]).asset_data.description=DESCRIPTION
            elif a=='NODETREE':
                bpy.data.node_groups.get(NAMES[i]).asset_data.description=DESCRIPTION 
    except:
        print("An Error Occured while updating author")
bpy.ops.wm.save_mainfile()
bk = FILEPATH + "1"
if os.path.exists(bk):
    os.remove(bk)
#bpy.ops.wm.quit_blender()
